/****************************************************
  McBSP pins test for T62.
  
  This test asumes that McBSPs are configured as I/O pins.

  The following external jumpers are required for each McBSP:
    DR=CLKS= DX, driven by DX output
    CLKX, CLKR, FSR, FSX are configured as outputs	

*****************************************************/

#include "c6x_def.h"


init_cpu()
{
	*C6X_EMIF_GCR=0x3078;
	*C6X_EMIF_CE0=0x40;
	*C6X_EMIF_CE1=0xffffff23;
	*C6X_EMIF_CE2=0xffffff23;
	*C6X_EMIF_CE3=0xffffff23;

}


#define DX_OUT_0      0x3f00
#define DX_OUT_1      0x3f20
#define FSX_OUT_0     0x3f00
#define FSX_OUT_1     0x3f08
#define FSR_OUT_0     0x3f00
#define FSR_OUT_1     0x3f04
#define CLKX_OUT_0    0x3f00
#define CLKX_OUT_1    0x3f02
#define CLKR_OUT_0    0x3f00
#define CLKR_OUT_1    0x3f01

#define DR_BIT_MASK   0x10
#define CLKS_BIT_MASK 0x40
#define CLKR_BIT_MASK 0x1
#define CLKX_BIT_MASK 0x2
#define FSX_BIT_MASK  0x8
#define FSR_BIT_MASK  0x4


unsigned pass_counter=0;

main()
{
   init_cpu();

   *C6X_MCBSP0_SPCR = 0;   /* configure McBSP for I/O pins */

   while(1)
    {
      /* verify for McBSP-0 */
	/* set DX=1 */
      *C6X_MCBSP0_PCR = DX_OUT_1;

      if(((*C6X_MCBSP0_PCR) & DR_BIT_MASK  ) ==0) break; 
      if(((*C6X_MCBSP0_PCR) & CLKS_BIT_MASK) ==0) break; 

	/* set DX=0 */
      *C6X_MCBSP0_PCR = DX_OUT_0;

      if((*C6X_MCBSP0_PCR & DR_BIT_MASK  ) !=0) break; 
      if((*C6X_MCBSP0_PCR & CLKS_BIT_MASK) !=0) break; 

      *C6X_MCBSP0_PCR = FSX_OUT_1;
      *C6X_MCBSP0_PCR = FSX_OUT_0;

      *C6X_MCBSP0_PCR = FSR_OUT_1;
      *C6X_MCBSP0_PCR = FSR_OUT_0;

      *C6X_MCBSP0_PCR = CLKX_OUT_1;
      *C6X_MCBSP0_PCR = CLKX_OUT_0;

      *C6X_MCBSP0_PCR = CLKR_OUT_1;
      *C6X_MCBSP0_PCR = CLKR_OUT_0;


      /* verify for McBSP-1 */
	/* set DX=1 */
      *C6X_MCBSP1_PCR = DX_OUT_1;

      if((*C6X_MCBSP1_PCR & DR_BIT_MASK  ) ==0) break; 
      if((*C6X_MCBSP1_PCR & CLKS_BIT_MASK) ==0) break; 

	/* set DX=0 */
      *C6X_MCBSP1_PCR = DX_OUT_0;

      if((*C6X_MCBSP1_PCR & DR_BIT_MASK  ) !=0) break; 
      if((*C6X_MCBSP1_PCR & CLKS_BIT_MASK) !=0) break; 

      *C6X_MCBSP1_PCR = FSX_OUT_1;
      *C6X_MCBSP1_PCR = FSX_OUT_0;

      *C6X_MCBSP1_PCR = FSR_OUT_1;
      *C6X_MCBSP1_PCR = FSR_OUT_0;

      *C6X_MCBSP1_PCR = CLKX_OUT_1;
      *C6X_MCBSP1_PCR = CLKX_OUT_0;

      *C6X_MCBSP1_PCR = CLKR_OUT_1;
      *C6X_MCBSP1_PCR = CLKR_OUT_0;

     pass_counter++;
    }


  error:
    while(1) ;

}



