/****************************************************
  SBSRAM 512Kx32 memory test for T62
	

*****************************************************/

unsigned *ptr ;

#define	DMEM_START_PTR	((unsigned *) 0x0)
#define	DMEM_END_PTR	((unsigned *) 0x1fffff)

unsigned *EMIF_GCR        = (unsigned *) 0x01800000;
unsigned *EMIF_CE0        = (unsigned *) 0x01800008;
unsigned *EMIF_CE1        = (unsigned *) 0x01800004;
unsigned *EMIF_CE2        = (unsigned *) 0x01800010;
unsigned *EMIF_CE3        = (unsigned *) 0x01800014;
unsigned *EMIF_SDRAM      = (unsigned *) 0x01800018;
unsigned *EMIF_SDRAM_TIMER= (unsigned *) 0x0180001c;



init_cpu()
{
	*EMIF_GCR=0x3078;
	*EMIF_CE0=0x40;
	*EMIF_CE1=0xffffff23;
	*EMIF_CE2=0xffffff23;
	*EMIF_CE3=0xffffff23;
}


unsigned start_data = 0xa596e73b,
         start_data_block;
unsigned mem_inc_data = 0x97b5f3be;
unsigned mem_wr_data, mem_rd_data;
unsigned pass_counter=0;


main()
{
   init_cpu();

   while(1)
    {
      start_data_block= start_data;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ; *ptr++ = mem_wr_data++);

          start_data += mem_inc_data ;

      start_data=start_data_block;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;	)
   	   {
	     mem_rd_data = *ptr;
             if(mem_rd_data != mem_wr_data) goto error ;
	     ++ptr; mem_wr_data++;
	   }
          start_data += mem_inc_data ;

     pass_counter++;

    }


  error:
    while(1) ;

}


