/****************************************************
  on-chip PMEM test for T62
	

*****************************************************/

unsigned *ptr ;

#define	DMEM_START_PTR	((unsigned *) 0x01408000)
#define	DMEM_END_PTR	((unsigned *) 0x0140ffff)

unsigned *EMIF_GCR        = (unsigned *) 0x01800000;
unsigned *EMIF_CE0        = (unsigned *) 0x01800008;
unsigned *EMIF_CE1        = (unsigned *) 0x01800004;
unsigned *EMIF_CE2        = (unsigned *) 0x01800010;
unsigned *EMIF_CE3        = (unsigned *) 0x01800014;
unsigned *EMIF_SDRAM      = (unsigned *) 0x01800018;
unsigned *EMIF_SDRAM_TIMER= (unsigned *) 0x0180001c;

unsigned *C6X_DMA0_PCRG		= (unsigned *) 0x01840000;
unsigned *C6X_DMA0_SCRG		= (unsigned *) 0x01840008;
unsigned *C6X_DMA0_SARG		= (unsigned *) 0x01840010;
unsigned *C6X_DMA0_DARG		= (unsigned *) 0x01840018;
unsigned *C6X_DMA0_TCRG		= (unsigned *) 0x01840020;
unsigned *C6X_DMA0_GAARG	= (unsigned *) 0x01840038;
unsigned *C6X_DMA0_GABRG	= (unsigned *) 0x0184003C;
unsigned *C6X_DMA0_GACRG	= (unsigned *) 0x01840068;
unsigned *C6X_DMA0_GADRG	= (unsigned *) 0x0184006C;
unsigned *C6X_DMA0_GCRARG	= (unsigned *) 0x01840028;
unsigned *C6X_DMA0_GCRBRG	= (unsigned *) 0x0184002C;
unsigned *C6X_DMA0_GIARG	= (unsigned *) 0x01840030;
unsigned *C6X_DMA0_GIBRG	= (unsigned *) 0x01840034;


init_cpu()
{
	*EMIF_GCR=0x3078;
	*EMIF_CE0=0x40;
	*EMIF_CE1=0xffffff23;
	*EMIF_CE2=0xffffff23;
	*EMIF_CE3=0xffffff23;
}


unsigned start_data = 0xa596e73b,
         start_data_block;
unsigned mem_inc_data = 0x97b5f3be;
unsigned mem_wr_data,mem_rd_data;
unsigned pass_counter=0;


	// function to transfer 32-bitwords via DMA0
void	copy_dma_w32(unsigned *ps,unsigned *pd, unsigned short count)
{
  *C6X_DMA0_PCRG=0x01000050;	// set 32-bit transfers and DMA priority
  *C6X_DMA0_SCRG=0;
  *C6X_DMA0_SARG=(unsigned)ps;
  *C6X_DMA0_DARG=(unsigned)pd;
  *C6X_DMA0_TCRG=(count & 0xffff);

  *C6X_DMA0_PCRG|=0x1; // start DMA0
  while(((*C6X_DMA0_PCRG)&0xc)!=0);	// wait until DMA0 stops

}




main()
{
   init_cpu();

   while(1)
    {
      start_data_block= start_data;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ; ptr++, mem_wr_data++)
	      { copy_dma_w32(&mem_wr_data,ptr,1); // *ptr = mem_wr_data;
	       };

          start_data += mem_inc_data ;

      start_data=start_data_block;

          for(mem_wr_data=start_data, ptr=DMEM_START_PTR;
	      ptr<=DMEM_END_PTR ;ptr++,mem_wr_data++	)
   	   { copy_dma_w32(ptr,&mem_rd_data,1);
             if(mem_rd_data != mem_wr_data) goto error ;
	   }
          start_data += mem_inc_data ;

     pass_counter++;

    }


  error:
    while(1) ;

}


