/****************************************************
  TIMERs test for T62
	
  This test uses TIMER as I/O port.
  This test requires the TOUT jumper to be installed,
  i.e. TINP pin is verified to be equal to TOUT data.
*****************************************************/

unsigned *EMIF_GCR        = (unsigned *) 0x01800000;
unsigned *EMIF_CE0        = (unsigned *) 0x01800008;
unsigned *EMIF_CE1        = (unsigned *) 0x01800004;
unsigned *EMIF_CE2        = (unsigned *) 0x01800010;
unsigned *EMIF_CE3        = (unsigned *) 0x01800014;
unsigned *EMIF_SDRAM      = (unsigned *) 0x01800018;
unsigned *EMIF_SDRAM_TIMER= (unsigned *) 0x0180001c;


unsigned *TM0_CONTROL     = (unsigned *) 0x01940000;
unsigned *TM0_PERIOD      = (unsigned *) 0x01940004;
unsigned *TM0_COUNTER     = (unsigned *) 0x01940008;
unsigned *TM1_CONTROL     = (unsigned *) 0x01980000;
unsigned *TM1_PERIOD      = (unsigned *) 0x01980004;
unsigned *TM1_COUNTER     = (unsigned *) 0x01980008;


init_cpu()
{
	*EMIF_GCR=0x3078;
	*EMIF_CE0=0x40;
	*EMIF_CE1=0xffffff23;
	*EMIF_CE2=0xffffff23;
	*EMIF_CE3=0xffffff23;
}

#define TM_OUT_0  0
#define TM_OUT_1  4

unsigned pass_counter=0;

main()
{
   init_cpu();

   *TM0_CONTROL=0;

   while(1)
    {
      /* verify for TINP==TOUT for TIMER-0 */
	/* set TOUT=0 */
      *TM0_CONTROL = TM_OUT_0;
	/* check for TINP==TOUT */
      if((*TM0_CONTROL & 8) !=0) break; 

	/* set TOUT=1 */
      *TM0_CONTROL = TM_OUT_1;
	/* check for TINP==TOUT */
      if((*TM0_CONTROL & 8) ==0) break; 


      /* verify for TINP==TOUT for TIMER-1 */
	/* set TOUT=0 */
      *TM1_CONTROL = TM_OUT_0;
	/* check for TINP==TOUT */
      if((*TM1_CONTROL & 8) !=0) break; 

	/* set TOUT=1 */
      *TM1_CONTROL = TM_OUT_1;
	/* check for TINP==TOUT */
      if((*TM1_CONTROL & 8) ==0) break; 


     pass_counter++;
    }


  error:
    while(1) ;

}


