
/*

	Testing T6x memory via HPI

*/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include "t6x_h.c"

#include <ips_ut.h>

unsigned long	START_SADDR = 0x0L,
                LAST_SADDR  = 0x7fffL;

unsigned long sa;
unsigned long data,data_start, data_rd, data_x,data_start_x, data_rd_x,
         initial_data   = 0xe97fa5f7l,
         initial_data_x = 0x39f0e7ael,
	 data_inc     = 0xb5f13fe9l,
	 data_inc_x     = 0x491fe3adl;
int ex_status;

#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");

char err_mess[100];
unsigned sn;




 main()

 { int r;


   printf("\nTORNADO-6x HPI test. v.1.0\n");
   printf("Copyright (C) MicroLAB Systems Ltd, 1996-1999\n\n");

   if((r=T6X_open(0x350))!=T6X_OK)
       { error:
                 T6X_last_err_message(err_mess);
	         printf("\n error: %s\n",err_mess);
		 goto exit;
       }


   T6X_dev_id_data(&sn);
   sn &= 0xff;

   switch(T6X_id())
       { case T62_DEV_ID:
	    	printf("TORNADO-62 board, s/n: #%x\n\n",sn);
	    	break;

         case T67_DEV_ID:
	    	printf("TORNADO-67 board, s/n: #%x\n\n",sn);
	    	break;

         default:
	    	printf("internal error. exit...\n\n");
	    	break;
       }



   T6X_SET_MRESET;
   if((r=T6X_set_ecc_off())!=T6X_OK ) goto error;


   printf("\npress ESC to abort and exit to DOS ...\n\n");


   T6X_SET_MGO;

   T6X_HPI_INIT;
   T6X_CLR_HPI_ERR;
   T6X_SET_HPI_ERR_IE_ON;	// enable IRW on HPI_ERR for event sync flag

   data_start = initial_data;
   data_start_x = initial_data_x;

   while(1)
     {

// test for on-chip data memory

	CLEAR_CURRENT_LINE;
	printf("\rtesting DSP on-chip data memory...   ");

	START_SADDR	= 0x80000000l;
	LAST_SADDR	= 0x8000ffffl;

           //-- fill HPI data using direct address mode
           data = data_start;

             if( key_pressed() && read_char()==KEY_ESC)
	       {
	         printf("\nUser aborted. status: OK\n\n");
	         goto exit;
	       }

           for (sa=START_SADDR;sa<LAST_SADDR;sa+=4L,data++)
	      {
		if((sa%0x4000L)==0)   printf("w");
	        T6X_SET_HPIA(sa);
		T6X_SET_HPID(data);

		if(T6X_HPI_ERR_DATA!=0)
		   { printf("\nerror: HPI timeout error at write to HPI-A %lXH\n",sa);
		     goto exit;
		   }
	      }



             // verify HPI data using address auto increment mode
           data = data_start;
           T6X_SET_HPIA(START_SADDR);

           for (sa=START_SADDR;sa<LAST_SADDR;sa+=4L,data++)
	      {
		if((sa%0x4000L)==0)   printf("r");
		data_rd=T6X_HPID_AINC_DATA;

		if(T6X_HPI_ERR_DATA!=0)
		   { printf("\nerror: HPI timeout error at read from HPI-A %lxH\n",sa);
		     goto exit;
		    }
		if(data_rd!=data)
		  {
		    printf("\nerror: HPI-A=%lxH data_wr=%lxH  data_rd=%lxH\n\n",
			      sa, data, data_rd );
		    goto exit;

		  };
	      }


// test for external SRAM

	CLEAR_CURRENT_LINE;
	printf("\rtesting 512Kx32 external SBSRAM...   ");

	START_SADDR	= 0x0l;
	LAST_SADDR	= 0x1fffffl;

           //-- fill HPI data using direct address mode
           data_x = data_start_x;

             if( key_pressed() && read_char()==KEY_ESC)
	       {
	         printf("\nUser aborted. status: OK\n\n");
	         goto exit;
	       }

           for (sa=START_SADDR;sa<LAST_SADDR;sa+=4L,data_x++)
	      {
		if((sa%0x8000L)==0)   printf("w");
	        T6X_SET_HPIA(sa);
		T6X_SET_HPID(data_x);

		if(T6X_HPI_ERR_DATA!=0)
		   { printf("\nerror: HPI timeout error at write to HPI-A %lXH\n",sa);
		     goto exit;
		   }
	      }



             // verify HPI data using address auto increment mode
           data_x = data_start_x;
           T6X_SET_HPIA(START_SADDR);

           for (sa=START_SADDR;sa<LAST_SADDR;sa+=4L,data_x++)
	      {
		if((sa%0x8000L)==0)   printf("r");
		data_rd_x=T6X_HPID_AINC_DATA;

		if(T6X_HPI_ERR_DATA!=0)
		   { printf("\nerror: HPI timeout error at read from HPI-A %lxH\n",sa);
		     goto exit;
		    }
		if(data_rd_x!=data_x)
		  {
		    printf("\nerror: HPI-A=%lxH data_wr=%lxH  data_rd=%lxH\n\n",
			      sa, data_x, data_rd_x );
		    goto exit;

		  };
	      }


       data_start	+= data_inc ;
       data_start_x	+= data_inc_x ;
      }
	
   exit:
   T6X_SET_MRESET;
    ;
 }




